const mnuOpenId = "open-with-powerpoint";
const mnuOpenText = "Open with PowerPoint";
const mnUnzipid = "convert";
const mnUnzipText = "Convert to PNG";

class BackgroundPage {

    completePromises = [];

    initialize() {
        // chrome.contextMenus.create({
        //     id: mnuOpenId,
        //     title: mnuOpenText,
        //     contexts: ["link", "page", "frame"],
        // });
        //  chrome.contextMenus.create({
        //     id: mnuOpenIdrar,
        //     title: mnuOpenTextRar,
        //     contexts: ["link", "page", "frame"],
        // });
         chrome.contextMenus.create({
            id: mnUnzipid,
            title: mnUnzipText,
            contexts: ["link", "page", "frame"],
             "onclick": function (e) {
       chrome.tabs.create({ url: "../convert.html" }); }
        });

        chrome.contextMenus.onClicked.addListener((info, tab) => this.onCtxMenuClicked(info, tab));
        chrome.contextMenus.onClicked.addListener((info, tab) => this.onCtxMenuClickedRar(info, tab));
    }

    async onCtxMenuClicked(info, tab) {
        if (info.menuItemId != mnuOpenId) {
            return;
        }

        const url = info.linkUrl || info.srcUrl || info.pageUrl || info.frameUrl;

        if (!url) {
            return;
        }

        const item = await this.downloadAsync(url);
        console.debug(item);

        chrome.downloads.open(item.id);
    }

        async onCtxMenuClickedRar(info, tab) {
        if (info.menuItemId != mnuOpenIdrar) {
            return;
        }
        
        const url = info.linkUrl || info.srcUrl || info.pageUrl || info.frameUrl;

        if (!url) {
            return;
        }

        const item = await this.downloadAsync(url);
        console.debug(item);

        chrome.downloads.open(item.id);
    }

    async downloadAsync(url) {
        const id = await this._createDownloadAsync(url);

        while (true) {
            const item = await this._getDownloadByIdAsync(id);

            if (!item) {
                throw "USER_CANCELED";
            }

            switch (item.state) {
                case "complete":
                    return item;
                case "interrupted":
                    throw item.error;
            }

            await this.sleepShortAsync();
        }
    }

    _getDownloadByIdAsync(id) {
        return new Promise((resolve, reject) => {
            try {
                chrome.downloads.search({
                    id: id,
                }, items => resolve(items[0]));
            } catch (e) {
                reject(chrome.runtime.lastError);
            }
        });
    }

    _createDownloadAsync(url) {
        return new Promise((resolve, reject) => {
            try {
                chrome.downloads.download({
                    url: url,
                }, resolve);
            } catch (e) {
                reject(chrome.runtime.lastError);
            }
        });
    }

    sleepShortAsync() {
        return new Promise(resolve => {
            window.setTimeout(resolve, 200);
        });
    }

}

new BackgroundPage().initialize();